'From Cuis 1.0 of 2 October 2009 [latest update: #316] on 30 October 2009 at 11:35:55 pm'!

!Behavior methodsFor: 'as yet unclassified' stamp: 'jmv 10/27/2009 21:19'!
environment
	"Return the environment in which the receiver is visible"
	^Smalltalk! !


!Character methodsFor: 'as yet unclassified' stamp: 'jmv 10/28/2009 18:30'!
charCode ^ value! !


!ClassBuilder methodsFor: 'class definition' stamp: 'jmv 10/27/2009 21:49'!
name: className inEnvironment: popo subclassOf: newSuper type: type instanceVariableNames: instVarString classVariableNames: classVarString poolDictionaries: poolString category: category
	"Define a new class in the given environment"
	^self 
		name: className 
		subclassOf: newSuper 
		type: type 
		instanceVariableNames: instVarString 
		classVariableNames: classVarString 
		poolDictionaries: poolString 
		category: category
		unsafe: false! !


!Debugger methodsFor: '*Shout-Styling' stamp: 'jmv 10/30/2009 23:35'!
shoutAboutToStyle: aSHTextStyler
	"This is a notification that aSHTextStyler is about to re-style its text.
	Set the classOrMetaClass in aSHTextStyler, so that identifiers
	will be resolved correctly.
	Answer true to allow styling to proceed, or false to veto the styling"
	
	self shoutIsModeStyleable ifFalse: [^false].
	aSHTextStyler 
		classOrMetaClass: self selectedClassOrMetaClass";
		sourceMap: (sourceMap ifNil:[self pcRange. sourceMap])".
		"build the sourceMap now by calling pcRange"
	^true! !


!Preferences class methodsFor: 'add preferences' stamp: 'jmv 10/28/2009 18:25'!
addBooleanPreference: prefSymbol category: categorySymbol default: defaultValue balloonHelp: helpString 
	"Add the given preference, putting it in the given category, with the given default value, and with the given balloon help"

	self addPreference: prefSymbol categories: {categorySymbol} default: defaultValue balloonHelp: helpString ! !


!UndefinedObject methodsFor: 'as yet unclassified' stamp: 'jmv 10/27/2009 21:20'!
environment
	"Necessary to support disjoint class hierarchies."

	^self class environment! !

